/* tslint:disable */
/* eslint-disable */
/**
*/
export class DateAggregator {
  free(): void;
/**
* @param {string} time_unit
*/
  constructor(time_unit: string);
/**
* @param {string} date_str
* @returns {string}
*/
  apply_on_date(date_str: string): string;
}
/**
*/
export class Hasher {
  free(): void;
/**
* @param {string} hasher_method
* @param {Uint8Array | undefined} [salt_opt]
*/
  constructor(hasher_method: string, salt_opt?: Uint8Array);
/**
* @param {string} data
* @returns {string}
*/
  apply_str(data: string): string;
/**
* @param {Uint8Array} data
* @returns {Uint8Array}
*/
  apply_bytes(data: Uint8Array): Uint8Array;
}
/**
*/
export class NoiseGeneratorWithBounds {
  free(): void;
/**
* @param {string} method_name
* @param {number} min_bound
* @param {number} max_bound
*/
  constructor(method_name: string, min_bound: number, max_bound: number);
/**
* @param {number} data
* @returns {number}
*/
  apply_on_float(data: number): number;
/**
* @param {Float64Array} data
* @param {Float64Array} factors
* @returns {Float64Array}
*/
  apply_correlated_noise_on_floats(data: Float64Array, factors: Float64Array): Float64Array;
/**
* @param {bigint} data
* @returns {bigint}
*/
  apply_on_int(data: bigint): bigint;
/**
* @param {BigInt64Array} data
* @param {Float64Array} factors
* @returns {BigInt64Array}
*/
  apply_correlated_noise_on_ints(data: BigInt64Array, factors: Float64Array): BigInt64Array;
/**
* @param {string} date
* @returns {string}
*/
  apply_on_date(date: string): string;
/**
* @param {string} data
* @param {Float64Array} factors
* @returns {string}
*/
  apply_correlated_noise_on_dates(data: string, factors: Float64Array): string;
}
/**
*/
export class NoiseGeneratorWithParameters {
  free(): void;
/**
* @param {string} method_name
* @param {number} mean
* @param {number} std_dev
*/
  constructor(method_name: string, mean: number, std_dev: number);
/**
* @param {number} data
* @returns {number}
*/
  apply_on_float(data: number): number;
/**
* @param {Float64Array} data
* @param {Float64Array} factors
* @returns {Float64Array}
*/
  apply_correlated_noise_on_floats(data: Float64Array, factors: Float64Array): Float64Array;
/**
* @param {bigint} data
* @returns {bigint}
*/
  apply_on_int(data: bigint): bigint;
/**
* @param {BigInt64Array} data
* @param {Float64Array} factors
* @returns {BigInt64Array}
*/
  apply_correlated_noise_on_ints(data: BigInt64Array, factors: Float64Array): BigInt64Array;
/**
* @param {string} date
* @returns {string}
*/
  apply_on_date(date: string): string;
/**
* @param {string} data
* @param {Float64Array} factors
* @returns {string}
*/
  apply_correlated_noise_on_dates(data: string, factors: Float64Array): string;
}
/**
*/
export class NumberAggregator {
  free(): void;
/**
* @param {number} power_of_ten
*/
  constructor(power_of_ten: number);
/**
* @param {number} data
* @returns {string}
*/
  apply_on_float(data: number): string;
/**
* @param {bigint} data
* @returns {string}
*/
  apply_on_int(data: bigint): string;
}
/**
*/
export class NumberScaler {
  free(): void;
/**
* @param {number} mean
* @param {number} std_deviation
* @param {number} scale
* @param {number} translate
*/
  constructor(mean: number, std_deviation: number, scale: number, translate: number);
/**
* @param {number} data
* @returns {number}
*/
  apply_on_float(data: number): number;
/**
* @param {bigint} data
* @returns {bigint}
*/
  apply_on_int(data: bigint): bigint;
}
/**
*/
export class WordMasker {
  free(): void;
/**
* @param {string} words_to_block
*/
  constructor(words_to_block: string);
/**
* @param {string} data
* @returns {string}
*/
  apply(data: string): string;
}
/**
*/
export class WordPatternMasker {
  free(): void;
/**
* @param {string} pattern_regex
* @param {string} replace_str
*/
  constructor(pattern_regex: string, replace_str: string);
/**
* @param {string} data
* @returns {string}
*/
  apply(data: string): string;
}
/**
*/
export class WordTokenizer {
  free(): void;
/**
* @param {string} words_to_block
*/
  constructor(words_to_block: string);
/**
* @param {string} data
* @returns {string}
*/
  apply(data: string): string;
}

export type InitInput = RequestInfo | URL | Response | BufferSource | WebAssembly.Module;

export interface InitOutput {
  readonly memory: WebAssembly.Memory;
  readonly __wbg_wordmasker_free: (a: number) => void;
  readonly wordmasker_new: (a: number, b: number) => number;
  readonly wordmasker_apply: (a: number, b: number, c: number, d: number) => void;
  readonly __wbg_wordtokenizer_free: (a: number) => void;
  readonly wordtokenizer_new: (a: number, b: number, c: number) => void;
  readonly wordtokenizer_apply: (a: number, b: number, c: number, d: number) => void;
  readonly __wbg_wordpatternmasker_free: (a: number) => void;
  readonly wordpatternmasker_new: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly wordpatternmasker_apply: (a: number, b: number, c: number, d: number) => void;
  readonly noisegeneratorwithparameters_new: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly __wbg_noisegeneratorwithbounds_free: (a: number) => void;
  readonly noisegeneratorwithbounds_new: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly noisegeneratorwithparameters_apply_correlated_noise_on_dates: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly noisegeneratorwithbounds_apply_on_float: (a: number, b: number) => number;
  readonly noisegeneratorwithbounds_apply_correlated_noise_on_floats: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly noisegeneratorwithbounds_apply_on_int: (a: number, b: number) => number;
  readonly noisegeneratorwithbounds_apply_correlated_noise_on_ints: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly noisegeneratorwithbounds_apply_on_date: (a: number, b: number, c: number, d: number) => void;
  readonly noisegeneratorwithbounds_apply_correlated_noise_on_dates: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly noisegeneratorwithparameters_apply_on_float: (a: number, b: number) => number;
  readonly noisegeneratorwithparameters_apply_on_int: (a: number, b: number) => number;
  readonly noisegeneratorwithparameters_apply_correlated_noise_on_floats: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly noisegeneratorwithparameters_apply_correlated_noise_on_ints: (a: number, b: number, c: number, d: number, e: number, f: number) => void;
  readonly noisegeneratorwithparameters_apply_on_date: (a: number, b: number, c: number, d: number) => void;
  readonly __wbg_noisegeneratorwithparameters_free: (a: number) => void;
  readonly __wbg_hasher_free: (a: number) => void;
  readonly hasher_new: (a: number, b: number, c: number, d: number, e: number) => void;
  readonly hasher_apply_str: (a: number, b: number, c: number, d: number) => void;
  readonly hasher_apply_bytes: (a: number, b: number, c: number, d: number) => void;
  readonly numberaggregator_new: (a: number, b: number) => void;
  readonly numberaggregator_apply_on_float: (a: number, b: number, c: number) => void;
  readonly numberaggregator_apply_on_int: (a: number, b: number, c: number) => void;
  readonly __wbg_dateaggregator_free: (a: number) => void;
  readonly dateaggregator_new: (a: number, b: number, c: number) => void;
  readonly dateaggregator_apply_on_date: (a: number, b: number, c: number, d: number) => void;
  readonly __wbg_numberscaler_free: (a: number) => void;
  readonly numberscaler_new: (a: number, b: number, c: number, d: number) => number;
  readonly numberscaler_apply_on_float: (a: number, b: number) => number;
  readonly numberscaler_apply_on_int: (a: number, b: number) => number;
  readonly __wbg_numberaggregator_free: (a: number) => void;
  readonly __wbindgen_export_0: (a: number, b: number) => number;
  readonly __wbindgen_export_1: (a: number, b: number, c: number, d: number) => number;
  readonly __wbindgen_add_to_stack_pointer: (a: number) => number;
  readonly __wbindgen_export_2: (a: number, b: number, c: number) => void;
  readonly __wbindgen_export_3: (a: number) => void;
}

export type SyncInitInput = BufferSource | WebAssembly.Module;
/**
* Instantiates the given `module`, which can either be bytes or
* a precompiled `WebAssembly.Module`.
*
* @param {SyncInitInput} module
*
* @returns {InitOutput}
*/
export function initSync(module: SyncInitInput): InitOutput;

/**
* If `module_or_path` is {RequestInfo} or {URL}, makes a request and
* for everything else, calls `WebAssembly.instantiate` directly.
*
* @param {InitInput | Promise<InitInput>} module_or_path
*
* @returns {Promise<InitOutput>}
*/
export default function __wbg_init (module_or_path?: InitInput | Promise<InitInput>): Promise<InitOutput>;
